#! /bin/sh
### BEGIN INIT INFO
# Provides:          mx_html5
# Required-Start:    rainbows
# Required-Stop:     rainbows
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
### END INIT INFO


PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON="/usr/bin/java"
DESC=mx_java_server

min_heap_size="1024m"
max_heap_size="2048m"

serverdir=/home/ewhine/deploy/mx_java_server
serverjar=server.jar
server_temp=$serverdir/tmp
server_logs=$serverdir/log
server_name="mx_java_server"
PIDFILE=$server_temp/$server_name.pid
USER=ewhine
DB_ENV=production

test -x $DAEMON || exit 0
test -x $serverdir || exit 0

set -e
iden=mx_server_a9850398
identity="-Didentity=$iden"


ARGS="-server -Xms$min_heap_size -Xmx$max_heap_size -XX:PermSize=128m -Xloggc:$server_logs/gc.log -XX:+PrintGCTimeStamps -XX:-PrintGCDetails -Drack.env=production -Djava.awt.headless=true -jar $serverjar"
case "$1" in
  start)
    PID=`ps aux|grep $iden|grep -v grep|awk '{print $2}'`
    if [ -f $PIDFILE  ]; then
        if [ "`cat $PIDFILE`" == "$PID" ]; then
            echo "$server_name has already been started!"
            exit 0;
        else
            echo "$server_name may be crashed.Will start it."
        fi
    fi
	echo -n "Starting $DESC... "
	touch $PIDFILE
        chown "$USER" $PIDFILE
	if start-stop-daemon --start --chdir $serverdir --quiet --make-pidfile --background --pidfile $PIDFILE --chuid "$USER" --exec $DAEMON -- $identity $ARGS
	then
		echo "done."
	else
		echo "failed"
	fi
	;;
  stop)
	echo -n "Stopping $DESC... "
	if start-stop-daemon --stop --retry 10 --quiet --pidfile $PIDFILE
	then
		echo "done."
	else
		echo "failed"
	fi
	rm -f $PIDFILE
	;;

  restart|force-reload)
	${0} stop
	${0} start
	;;
  *)
	echo "Usage: /etc/init.d/$server_name {start|stop|restart|force-reload}" >&2
	exit 1
	;;
esac

exit 0